package MonteCarlo;

import java.util.Vector;

/* Java KnockAbout Client
 * By :Maxime Chambreuil
 * Student Id #:2600675702
 */

class AIPlayer extends Player{
   
    AIPlayer(){
        setMyName("Monte Carlo player");
    }
    
    public Move chooseMove(Board board){
    	Distance myDistance = new Distance();
	int myTotalDistance = 0,oppTotalDistance = 0,maxDistance =0,minDistance = 100000,newval = 0;
	Move myMove = new Move(0,0,0);
	Vector moveList = myDistance.getAllPossibleMove(board,getMyColor());
	Vector oppMoveList = new Vector();
	Board firstBoard,secondBoard;
	
	// For all my possible move
	for (int i=0;i<moveList.size();i++){
	    // Clone the board to apply the move
	    firstBoard = board.deepclone();
	    // Apply the current move to the board
	    firstBoard.applyMove( (Move) moveList.get(i),getMyColor(),newval);
	    // Get the list of the opponent possible move
	    oppMoveList = myDistance.getAllPossibleMove(firstBoard,getOpponentColor());
	    // (Re)-Initialization
	    oppTotalDistance = 0;
	    myTotalDistance = 0;
	    // For all opponent possible move
	    for (int j=0;j<oppMoveList.size();j++){
		// Clone the board to apply the move
		secondBoard = firstBoard.deepclone();
		// Apply the current move to the board
		secondBoard.applyMove( (Move) oppMoveList.get(j),getOpponentColor(),newval);
		// Evaluate the board and add the value to the total distance
		myTotalDistance = myTotalDistance + myDistance.getDistanceEvaluationOfABoard(secondBoard,getMyColor());
		oppTotalDistance = oppTotalDistance + myDistance.getDistanceEvaluationOfABoard(secondBoard,getOpponentColor());
	    }
	    
	    // We substract and we average
	    myTotalDistance = (myTotalDistance - oppTotalDistance)/oppMoveList.size();
	    
	    if (myTotalDistance<minDistance){
		minDistance = myTotalDistance;
		myMove = (Move) moveList.get(i);
	    }
	}
	return myMove;
    };
}
