package MonteCarlo;

/* The Knockabout Die Class
 * =========================
 * Represents a game die.
 * Each game die has a set number of sides and color.
 * Each die also has an (x,y) positional coordinate indicating it's position
 * on a GameBoard. The current value will vary throughout the game, and range 
 * between 1 and the number of die sides.
 */


public class Die{
	
        private int curval; //Current Value of the die (Between 1 and sides)
	private int sides; //How many sides does the die have?
	private int color; //Player Color
        private int x,y; //Die Position
        
	public Die(int _color, int _sides, int _curval)
	{
		curval= _curval;
		sides= _sides;
		color= _color;
	}

        //Returns the current value of the game die.
	public int curVal()
	{
		return curval;
	}

        //Returns the number of sides this die hsa
	public int getSides()
	{
		return sides;
	}

        //Returns the die's color
	public int getColor()
	{
		return color;
	}
        
        //Sets the current die's value to a new value
        public void setVal(int _val)
        {
            curval = _val;
        }
        
        //Creates a deep clone of this die
 	public Die deepclone()
        {
            return new Die(color, sides, curval);
        }
}
