package MonteCarlo;

import java.util.Vector;

/* Java KnockAbout Client
 * By : Maxime CHAMBREUIL
 * Student Id #:260067572
 */

class Distance {
   
    Distance() {}
    
    private int getDistanceBetweenPosition(int x1, int y1, int x2, int y2) {
	int X,Y;
	
	if (x1 < x2) 
	    X = x2-x1;
	else 
	    X = x1-x2;
	if (y1 < y2) 
	    Y = y2-y1;
	else 
	    Y = y1-y2;
	
	int distance = X+Y;
	
	if (X == Y && (x1-x2)*(y1-y2) > 0) distance = distance/2; // same diagonal
	
	return distance;
    }
        
    public int[] getNearestDieFromMiddle(Board myBoard,int playerColor){
	Hex hex; 
	int currentDistance;
	int minDistance = 14;
	int[] coord = new int[2];
	
	for (int i = 1;i < 13;i++) {
	    for (int j = 1;j < 13;j++) {
		if (myBoard.isValidCoord(i,j)) {
		    hex = myBoard.getHex(i,j);
		    
		    // The place is occupied by a right die
		    if (hex.isOccupied() && hex.getDie().getColor() == playerColor) {
			
			// I retrieve the distance between the die and the middle of the board
			currentDistance = getDistanceBetweenPosition(6,6,i,j);

			// I take the last die with the maximum distance
			if ( currentDistance < minDistance) {
			    minDistance = currentDistance;
			    coord[0] = i;
			    coord[1] = j;
			}
		    }
		}
	    }
	}
	return coord;
    }

    public int[] getMyNearestDieToADie(Board myBoard,int myColor,int[] oppCoord){
	Hex hex;
	int currentDistance;
	int minDistance = 14;
	int[] coord = new int[2];
	
	for (int i = 1;i < 12;i++) {
	    for (int j = 1;j < 12;j++) {
		if (myBoard.isValidCoord(i,j)) {
		    hex = myBoard.getHex(i,j);
		    
		    // The place is occupied by an opponent die
		    if (hex.isOccupied() && hex.getDie().getColor() == myColor) {
			
			// I retrieve the distance between the dies
			currentDistance = getDistanceBetweenPosition(oppCoord[0],oppCoord[1],i,j);
			
			// I take the last die with the maximum distance
			if (currentDistance < minDistance){
			    minDistance = currentDistance;
			    coord[0] = i;
			    coord[1] = j;
			}
		    }
		}
	    }
	}
	return coord;
    }
    
    public int getDistanceEvaluationOfABoard(Board myBoard,int playerColor){
	int distance=0;
	Hex hex;
	Move move;
	Vector MoveList = new Vector();        
	int index;
	
	for (int i = 0;i < 13;i++) {
	    for (int j = 0;j < 13;j++) {
		if (myBoard.isValidCoord(i,j)) {
		    hex = myBoard.getHex(i,j);
		    
		    // The place is occupied by a die
		    if (hex.isOccupied() && hex.getDie().getColor() == playerColor) {
			if (i==0 || i==12 || j==0 || j==12)
			    distance = distance + 100;
			// I update the distance with the one between the die 
			// and the middle of the board
			distance = distance + getDistanceBetweenPosition(6,6,i,j);
		    }
		}
	    }
	}
	return distance;
    }
    
    public int getDistanceEvaluationOfABoard(Board myBoard,int myColor,int oppColor){
	return getDistanceEvaluationOfABoard(myBoard,myColor) - getDistanceEvaluationOfABoard(myBoard,oppColor);
    }
    
    
    public Vector getAllPossibleMove(Board board,int playerColor){
	Hex hex;
	Move move;
	Vector moveList = new Vector();        
	
	for (int i = 1;i < 12;i++)
	    {
		for (int j = 1;j < 12;j++)
		    {
			if (board.isValidCoord(i,j))
			    {
				hex = board.getHex(i,j);
				if (hex.isOccupied() && hex.getDie().getColor() == playerColor)
				    {
					for (int direction = 0;direction < 6;direction++)
					    {
						move = new Move(i,j,direction);
						if (board.isValidMove(move,playerColor)) moveList.add(move);                     
					    }
				    }
			    }
		    }
	    }
	return moveList;
    }
    
    public Move getSimpleMove(int[] myCoord, int[] oppCoord){
	int direction = 0;
	if (myCoord[0] == oppCoord[0] && myCoord[1] - oppCoord[1] < 0) direction=3;
	if (myCoord[0] == oppCoord[0] && myCoord[1] - oppCoord[1] > 0) direction=2;
	if (myCoord[1] == oppCoord[1] && myCoord[0] - oppCoord[0] < 0) direction=5;
	if (myCoord[1] == oppCoord[1] && myCoord[0] - oppCoord[0] > 0) direction=1;
	if (myCoord[0] - myCoord[1] == oppCoord[0] - oppCoord[1] && myCoord[0] - oppCoord[0] > 0) direction=0;
	if (myCoord[0] - myCoord[1] == oppCoord[0] - oppCoord[1] && myCoord[0] - oppCoord[0] < 0) direction=4;
	
	return new Move(myCoord[0],myCoord[1],direction);
	
    };   
}
