package MonteCarlo;

/* KnockAbout Hexagon Object
 *=========================
 * Represents 1 tile on the Knockabout Game Board
 * This tile may or may not contain a die. A die-less tile is represented
 * when the die variable is set to null. Otherwise, that variable will point
 * to the die currently resting on the tile
 */

class Hex{
    
    private Die die; //The die occupying this tile (null if there is none)
    
    Hex(){
        die = null;
    }
    
    //Is there a die occupying this tile?
    public boolean isOccupied(){
        if (die != null) return(true);else return(false);
    }
    
    
    //Places a die on top of this tile. Caution: In it's current form, this function will
    //overwrite any die tbat was previously on this tile.
    
    public void putDie(Die _die){ //Places a die on this tile
        die = _die;
    }
    
    
    //Returns the die (if any) currently resting on this tile
    
    public Die getDie(){ //Retrieve the die on this tile
        return(die);
    }
    
    //Performs a deep clone of this tile
    
    public Hex deepclone(){ //Creates a copy of this object
        Hex h = new Hex();
        if (die != null) h.putDie(die.deepclone());
        return(h);
    }
    
} //End of Class Hex
