package MonteCarlo;

/* KnockAbout Move Object
 *=======================
 *This object represents a Knockabout game move.
 *Represents the (x,y) position to move to, as well as the direction of movement.
 *This class also contains some constants (DIR_XX's) and extra methods(ConvertDir)
 *for the purpose of mapping integer colors to their string equivalents.
 */

class Move{
    
    private int x,y,dir;
    
     //Define Direction Constants
    public static final int DIR_NW = 0;
    public static final int DIR_NE = 1;
    public static final int DIR_W = 2;
    public static final int DIR_E = 3;
    public static final int DIR_SE = 4;
    public static final int DIR_SW = 5;
    
    Move(int _x, int _y, int _dir){
        x = _x;
        y = _y;
        dir = _dir;
    }
    
      //Converts a String direction to its numerical equivalent
      public static int convertDir(String strdir)
	{
		if      (strdir.equals("NW")) return DIR_NW;
		else if (strdir.equals("NE")) return DIR_NE;
		else if (strdir.equals("E")) return DIR_E;
		else if (strdir.equals("W")) return DIR_W;
		else if (strdir.equals("SW")) return DIR_SW;
		else if (strdir.equals("SE")) return DIR_SE;
		else return -1;
	}

        //Converts a numerically stored direction to its String equivalent
	public static String convertDir(int dir)
	{
		if      (dir == DIR_NW) return new String("NW");
		else if (dir == DIR_NE) return new String("NE");
		else if (dir == DIR_E) return new String("E");
		else if (dir == DIR_W) return new String("W");
		else if (dir == DIR_SW) return new String("SW");
		else if (dir == DIR_SE) return new String("SE");
		else return null;
	}
        
    //Outputs the current move as a string
    public String toString(){
        return(x+" "+y+" "+Move.convertDir(dir));
    }
    
    //Returns X coordinate
    public int getX(){
        return(x);
    }
    
    //Returns Y coordinate
    public int getY(){
        return(y);
    }
    
    //Returns direction
    public int getDir(){
        return(dir);
    }
    
    //Performs a deep clone of this game move
    public Move deepclone(){
        return new Move(x,y,dir);
    }
    
} //End of Class Move
