package MonteCarlo;

/* Standard KnockAbout Player Class
 * ================================
 * Provides a set of functions that an agent should inherit
 * (i.e. Your AIPlayer class should be a subclass of this one)
 */

class Player{
    
    private String name;  //What is the agents name?
    private int color;  //What is the agents server-assigned game color?
    
    //Define Colors
    public static final int BLACK = 0;  //Black Player Color
    public static final int YELLOW = 1; //Yellow Player Color
    public static final int DRAW = 2; //Draw. No Winner.
    public static final int NOCOLOR = 3;  //Extra-Defined Color. Used to check 
                                 //for errors in client code, and can be ignored
    
    Player()
    {};
    
    //Sets an agent's name
    public void setMyName(String _name)
    {
        name = _name;
    }
    
    //Sets an agent's color
    public void setMyColor(int _color)
    {
        color = _color;
    }
    
    //Returns the agent's color
    public int getMyColor()
    {
        return(color);
    }
    
    //Returns the agent's name
    public String getMyName()
    {
        return(name);
    }
    
	//Returns the opponent's color
	public int getOpponentColor() {
		if (this.color == 0) 
			return 1;
		else 
			return 0;
	}
    
    public Move chooseMove(Board board){
        //Must be overridden in a subclass. Please don't invoke Player.chooseMove
        //Please implement AIPlayer.chooseMove() instead.
      Board temp = board.deepclone();
      System.out.println("Must be overridden in a subclass. Please don't invoke Player.chooseMove");
      System.out.println("Please implement AIPlayer.chooseMove() instead");
      return(null);
    }
    
   
} //End of Player Class


